<template>
    <div>
        <conference v-if="singleStreamMode" class="conference" :conference="data.conference" :statistics-visible="statisticsVisible"/>
        <div v-else class="participants">
            <participant class="participant" v-for="(participant) in data.participants" :key="participant.id" :participant="participant" :statistics-visible="statisticsVisible" @change_name="emit('onStageChangedParticipantName', participant, $event)"/>
            <me class="participant" :participant="data.me" :statistics-visible="statisticsVisible" @change_name="emit('onStageChangedMeName', $event)" v-show="selfView === true"/>
        </div>
    </div>
</template>

<script setup>

    import Conference from "./Conference.vue";
    import Participant from "./Participant.vue";
    import Me from "./Me.vue";

    defineProps({
        data: Object,
        singleStreamMode: Boolean,
        selfView: Boolean,
        statisticsVisible: Boolean
    });

    const emit = defineEmits(["onStageChangedParticipantName", "onStageChangedMeName"]);

</script>

<style scoped>

    .conference {
        width: 100%;
        height: 100%;
    }

    .participants {
        width: 100%;
        height: 100%;
        display: flex;
        justify-content: center;
    }

    .participant {
        position: relative;
        overflow: hidden;
        flex: 1 1 auto;
    }

    @media (max-aspect-ratio: 2/3) {

        .participants {
            flex-flow: column wrap;
        }

        .participant {
            width: auto;
        }

        /* 1 item */
        .participant:first-child:nth-last-child(1) {
            height: 100%;
        }

        /* 2 items */
        .participant:first-child:nth-last-child(2), .participant:first-child:nth-last-child(2) ~ .participant {
            height: 50%;
        }

        /* 3 items */
        .participant:first-child:nth-last-child(3), .participant:first-child:nth-last-child(3) ~ .participant {
            height: 33.3333%;
        }

        /* 4 items */
        .participant:first-child:nth-last-child(4), .participant:first-child:nth-last-child(4) ~ .participant {
            height: 50%;
        }

        /* 5 items */
        .participant:first-child:nth-last-child(5), .participant:first-child:nth-last-child(5) ~ .participant {
            height: 33.3333%;
        }

        /* 6 items */
        .participant:first-child:nth-last-child(6), .participant:first-child:nth-last-child(6) ~ .participant {
            height: 33.3333%;
        }

        /* 7 items */
        .participant:first-child:nth-last-child(7), .participant:first-child:nth-last-child(7) ~ .participant {
            height: 25%;
        }

        /* 8 items */
        .participant:first-child:nth-last-child(8), .participant:first-child:nth-last-child(8) ~ .participant {
            height: 25%;
        }

        /* 9 items */
        .participant:first-child:nth-last-child(9), .participant:first-child:nth-last-child(9) ~ .participant {
            height: 20%;
        }

        /* 10 items */
        .participant:first-child:nth-last-child(10), .participant:first-child:nth-last-child(10) ~ .participant {
            height: 20%;
        }

        /* 11 items */
        .participant:first-child:nth-last-child(11), .participant:first-child:nth-last-child(11) ~ .participant {
            height: 25%;
        }

        /* 12 items */
        .participant:first-child:nth-last-child(12), .participant:first-child:nth-last-child(12) ~ .participant {
            height: 25%;
        }

    }

    @media (min-aspect-ratio: 2/3) and (max-aspect-ratio: 4/3) {

        .participants {
            flex-flow: row wrap;
        }

        .participant {
            height: auto;
        }

        /* 1 item */
        .participant:first-child:nth-last-child(1) {
            width: 100%;
        }

        /* 2 items */
        .participant:first-child:nth-last-child(2), .participant:first-child:nth-last-child(2) ~ .participant {
            width: 100%;
        }

        /* 3 items */
        .participant:first-child:nth-last-child(3), .participant:first-child:nth-last-child(3) ~ .participant {
            width: 50%;
        }

        /* 4 items */
        .participant:first-child:nth-last-child(4), .participant:first-child:nth-last-child(4) ~ .participant {
            width: 50%;
        }

        /* 5 items */
        .participant:first-child:nth-last-child(5), .participant:first-child:nth-last-child(5) ~ .participant {
            width: 33.3333%;
        }

        /* 6 items */
        .participant:first-child:nth-last-child(6), .participant:first-child:nth-last-child(6) ~ .participant {
            width: 33.3333%;
        }

        /* 7 items */
        .participant:first-child:nth-last-child(7), .participant:first-child:nth-last-child(7) ~ .participant {
            width: 25%;
        }

        /* 8 items */
        .participant:first-child:nth-last-child(8), .participant:first-child:nth-last-child(8) ~ .participant {
            width: 33.3333%;
        }

        /* 9 items */
        .participant:first-child:nth-last-child(9), .participant:first-child:nth-last-child(9) ~ .participant {
            width: 33.3333%;
        }

        /* 10 items */
        .participant:first-child:nth-last-child(10), .participant:first-child:nth-last-child(10) ~ .participant {
            width: 25%;
        }

        /* 11 items */
        .participant:first-child:nth-last-child(11), .participant:first-child:nth-last-child(11) ~ .participant {
            width: 25%;
        }

        /* 12 items */
        .participant:first-child:nth-last-child(12), .participant:first-child:nth-last-child(12) ~ .participant {
            width: 25%;
        }

    }

    @media (min-aspect-ratio: 4/3) and (max-aspect-ratio: 5/2) {

        .participants {
            flex-flow: row wrap;
        }

        .participant {
            height: auto;
        }

        /* 1 item */
        .participant:first-child:nth-last-child(1) {
            width: 100%;
        }

        /* 2 items */
        .participant:first-child:nth-last-child(2), .participant:first-child:nth-last-child(2) ~ .participant {
            width: 50%;
        }

        /* 3 items */
        .participant:first-child:nth-last-child(3), .participant:first-child:nth-last-child(3) ~ .participant {
            width: 33.3333%;
        }

        /* 4 items */
        .participant:first-child:nth-last-child(4), .participant:first-child:nth-last-child(4) ~ .participant {
            width: 50%;
        }

        /* 5 items */
        .participant:first-child:nth-last-child(5), .participant:first-child:nth-last-child(5) ~ .participant {
            width: 33.3333%;
        }

        /* 6 items */
        .participant:first-child:nth-last-child(6), .participant:first-child:nth-last-child(6) ~ .participant {
            width: 33.3333%;
        }

        /* 7 items */
        .participant:first-child:nth-last-child(7), .participant:first-child:nth-last-child(7) ~ .participant {
            width: 25%;
        }

        /* 8 items */
        .participant:first-child:nth-last-child(8), .participant:first-child:nth-last-child(8) ~ .participant {
            width: 25%;
        }

        /* 9 items */
        .participant:first-child:nth-last-child(9), .participant:first-child:nth-last-child(9) ~ .participant {
            width: 33.3333%;
        }

        /* 10 items */
        .participant:first-child:nth-last-child(10), .participant:first-child:nth-last-child(10) ~ .participant {
            width: 20%;
        }

        /* 11 items */
        .participant:first-child:nth-last-child(11), .participant:first-child:nth-last-child(11) ~ .participant {
            width: 25%;
        }

        /* 12 items */
        .participant:first-child:nth-last-child(12), .participant:first-child:nth-last-child(12) ~ .participant {
            width: 25%;
        }

    }

    @media (min-aspect-ratio: 5/2) and (max-aspect-ratio: 4/1) {

        .participants {
            flex-flow: row wrap;
        }

        .participant {
            height: auto;
        }

        /* 1 item */
        .participant:first-child:nth-last-child(1) {
            width: 100%;
        }

        /* 2 items */
        .participant:first-child:nth-last-child(2), .participant:first-child:nth-last-child(2) ~ .participant {
            width: 50%;
        }

        /* 3 items */
        .participant:first-child:nth-last-child(3), .participant:first-child:nth-last-child(3) ~ .participant {
            width: 33.3333%;
        }

        /* 4 items */
        .participant:first-child:nth-last-child(4), .participant:first-child:nth-last-child(4) ~ .participant {
            width: 25%;
        }

        /* 5 items */
        .participant:first-child:nth-last-child(5), .participant:first-child:nth-last-child(5) ~ .participant {
            width: 33.3333%;
        }

        /* 6 items */
        .participant:first-child:nth-last-child(6), .participant:first-child:nth-last-child(6) ~ .participant {
            width: 33.3333%;
        }

        /* 7 items */
        .participant:first-child:nth-last-child(7), .participant:first-child:nth-last-child(7) ~ .participant {
            width: 25%;
        }

        /* 8 items */
        .participant:first-child:nth-last-child(8), .participant:first-child:nth-last-child(8) ~ .participant {
            width: 25%;
        }

        /* 9 items */
        .participant:first-child:nth-last-child(9), .participant:first-child:nth-last-child(9) ~ .participant {
            width: 20%;
        }

        /* 10 items */
        .participant:first-child:nth-last-child(10), .participant:first-child:nth-last-child(10) ~ .participant {
            width: 20%;
        }

        /* 11 items */
        .participant:first-child:nth-last-child(11), .participant:first-child:nth-last-child(11) ~ .participant {
            width: 16.6666%;
        }

        /* 12 items */
        .participant:first-child:nth-last-child(12), .participant:first-child:nth-last-child(12) ~ .participant {
            width: 16.6666%;
        }

    }

    @media (min-aspect-ratio: 4/1) {

        .participants {
            flex-flow: row wrap;
        }

        .participant {
            height: auto;
        }

        /* 1 item */
        .participant:first-child:nth-last-child(1) {
            width: 100%;
        }

        /* 2 items */
        .participant:first-child:nth-last-child(2), .participant:first-child:nth-last-child(2) ~ .participant {
            width: 50%;
        }

        /* 3 items */
        .participant:first-child:nth-last-child(3), .participant:first-child:nth-last-child(3) ~ .participant {
            width: 33.3333%;
        }

        /* 4 items */
        .participant:first-child:nth-last-child(4), .participant:first-child:nth-last-child(4) ~ .participant {
            width: 25%;
        }

        /* 5 items */
        .participant:first-child:nth-last-child(5), .participant:first-child:nth-last-child(5) ~ .participant {
            width: 20%;
        }

        /* 6 items */
        .participant:first-child:nth-last-child(6), .participant:first-child:nth-last-child(6) ~ .participant {
            width: 16.6666%;
        }

        /* 7 items */
        .participant:first-child:nth-last-child(7), .participant:first-child:nth-last-child(7) ~ .participant {
            width: 14.2857%;
        }

        /* 8 items */
        .participant:first-child:nth-last-child(8), .participant:first-child:nth-last-child(8) ~ .participant {
            width: 25%;
        }

        /* 9 items */
        .participant:first-child:nth-last-child(9), .participant:first-child:nth-last-child(9) ~ .participant {
            width: 20%;
        }

        /* 10 items */
        .participant:first-child:nth-last-child(10), .participant:first-child:nth-last-child(10) ~ .participant {
            width: 20%;
        }

        /* 11 items */
        .participant:first-child:nth-last-child(11), .participant:first-child:nth-last-child(11) ~ .participant {
            width: 16.6666%;
        }

        /* 12 items */
        .participant:first-child:nth-last-child(12), .participant:first-child:nth-last-child(12) ~ .participant {
            width: 16.6666%;
        }

    }

</style>